unit PrinterSetup;

interface
Uses printers,windows,SysUtils,Classes,WinSpool;
Type
TPrinterSetup = class
private
  {Declaraciones Privadas}
  Device, Driver, Port: array[0..CCHDEVICENAME] of char;
  DeviceMode:THandle;
  Procedure Refresh;
protected
  {Declaraciones Privadas}
public
  {Declaraciones publicas}
  Procedure SaveSetup(Filename:TFilename);
  Procedure LoadSetup(Filename:TFilename);
end;
TPrinterConfig=record
ADevice, ADriver, APort: array[0..CCHDEVICENAME] of char;
SizeOfDeviceMode:DWORD;
end;

implementation
Procedure TPrinterSetup.Refresh;
begin
{Refresca los datos de la impresora actual}
Printer.GetPrinter(Device, Driver, Port, DeviceMode);
end;
{Salva en un fichero la configuracion de la impresora}
Procedure TPrinterSetup.SaveSetup(Filename:TFilename);
var
StubDevMode: TDeviceMode;
SetupPrinter:TPrinterConfig;
FPrinterHandle:THandle;
fFileConfig:file of TPrinterConfig;
fFileDevMode:file of Char;
pDevMode:Pchar;
Contador:Integer;
begin
Refresh;
With SetupPrinter do
    begin
    StrLCopy(ADevice,Device,SizeOf(ADevice));
    StrLCopy(ADriver,Driver,SizeOf(ADriver));
    StrLCopy(APort,Port,SizeOf(APort));
    OpenPrinter(Device, FPrinterHandle, nil);
    SizeOfDeviceMode:=DocumentProperties(0,FPrinterHandle, Device, StubDevMode,StubDevMode, 0);
    end;
{Creamos el archivo}
AssignFile(fFileConfig, FileName);
ReWrite(fFileConfig);
{Escribimos la cabecera}
write(fFileConfig,SetupPrinter);
CloseFile(fFileConfig);
{Lo abrimos de nuevo para escribir los datos}
AssignFile(fFileDevMode, FileName);
Reset(fFileDevMode);
{Vamos al final del archivo}
Seek(fFileDevMode,FileSize(fFileDevMode));
pDevMode:=GlobalLock(DeviceMode);
for Contador:=0 to SetupPrinter.SizeOfDeviceMode-1 do
    begin
    write(fFileDevMode,pDevMode[Contador]);
    end;
CloseFile(fFileDevMode);
GlobalUnLock(DeviceMode);
end;

{Recupera de un fichero la configuracion de la impresora}
Procedure TPrinterSetup.LoadSetup(Filename:TFilename);
var
SetupPrinter:TPrinterConfig;
fFileConfig:file of TPrinterConfig;
fFileDevMode:file of Char;
ADeviceMode:Thandle;
pDevMode:Pchar;
Contador:Integer;
begin
{Solo si existe el archivo}
if FileExists(Filename) then
    begin
    {Leemos la cabecera}
    AssignFile(fFileConfig, FileName);
    Reset(fFileConfig);
    read(fFileConfig,SetupPrinter);
    CloseFile(fFileConfig);
    {Leemos los datos del DeviceMode}
    AssignFile(fFileDevMode, FileName);
    Reset(fFileDevMode);
    {Vamos principio de los datos de Device Mode}
    Seek(fFileDevMode,SizeOf(SetupPrinter));
    {Obtenemos el handle para DeviceMode}
    ADeviceMode:=GlobalAlloc(GHND,SetupPrinter.SizeOfDeviceMode);
    pDevMode:=GlobalLock(ADeviceMode);
    for Contador:=0 to SetupPrinter.SizeOfDeviceMode-1 do
        begin
        read(fFileDevMode,pDevMode[Contador]);
        end;
    CloseFile(fFileDevMode);
    GlobalUnLock(ADeviceMode);
    Printer.SetPrinter(SetupPrinter.ADevice, SetupPrinter.ADriver, SetupPrinter.APort, ADeviceMode);
    end;
end;
end.
